#include <iostream>
#ifdef MYMPI
#include <mpi.h>
#endif
#ifdef MYOMP
#include <omp.h>
#endif

int main(int argc, char *argv[])
{
    int rank = 0;
    int size = 1;
    int threads = 1;
#ifdef MYMPI
    MPI_Init(&argc, &argv);
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
#endif
#ifdef MYOMP
    threads = omp_get_max_threads();
#endif

    if (rank == 0)
    {
        std::cout << "Hello World on root rank " << rank << std::endl;
        std::cout << "Total number of ranks: " << size << std::endl;
        std::cout << "Number of threads/rank: " << threads << std::endl;
    }
#ifdef MYMPI
    MPI_Finalize();
#endif
    return 0;
}

